'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _rng = require('./rng');

var _rng2 = _interopRequireDefault(_rng);

var _xor = require('./generators/xor128');

var _xor2 = _interopRequireDefault(_xor);

var _function = require('./generators/function');

var _function2 = _interopRequireDefault(_function);

var _mathRandom = require('./generators/math-random');

var _mathRandom2 = _interopRequireDefault(_mathRandom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var PRNG_BUILTINS = {
  // TODO: add more prng from C++11 lib
  'xor128': _xor2.default,
  'function': _function2.default,
  'default': _mathRandom2.default
};

exports.default = function () {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var _args$ = args[0],
      arg0 = _args$ === undefined ? 'default' : _args$,
      rest = args.slice(1);


  switch (typeof arg0 === 'undefined' ? 'undefined' : _typeof(arg0)) {
    case 'object':
      if (arg0 instanceof _rng2.default) {
        return arg0;
      }
      break;

    case 'function':
      return new _function2.default(arg0);

    case 'string':
      var PRNG = PRNG_BUILTINS[arg0];
      if (PRNG) {
        return new (Function.prototype.bind.apply(PRNG, [null].concat(_toConsumableArray(rest))))();
      }
      break;
  }

  throw new Error('invalid RNG "' + arg0 + '"');
};
//# sourceMappingURL=rng-factory.js.map